Unit MatrSol;

Interface

Uses MatrDef,Diffy;

Procedure Llsq(M1,M2,X:PMatrix; IPIV:PMatrixInt; Eps:real;
               Var IER:integer; AUX:PMatrix);
{ 襭 - ࠢ  }

Procedure Sol(NEntry:byte; A,F,X:PMatrixF; Var B:PMatrixF;
              EAB:longint; Var EX:integer; Var Cond:extended;
              Var Error:integer);
{ 襭 - ࠢ ⮤ 宫 }

Function PSol(Entry:byte; A,F:PMatrixF; Rank:byte; Var EX:integer;
 X:PMatrixF; Var D,Cond,Teta:extended; EAB:integer; Var B:PMatrixF;
 SVal:PHeapMatrixFG):integer;
{ 襭 - ࠢ  }

Implementation

Type PWord=^word;

Procedure Llsq(M1,M2,X:PMatrix; Ipiv:PMatrixInt; Eps:real;
               Var IER:integer; Aux:PMatrix);
{ 襭 - ࠢ  }
Var M,N,L:byte;
    K,Jst,Kst,LN,II,Kpiv,Iend,LM,ID,J,I,Ist:integer;
    R,Piv,H,Sig,Tol,Beta:extended;
Begin
 M:=M1^.Lines; N:=M1^.Cols; L:=M2^.Cols;

 If M<N then begin
  IER:=-2; exit
 end;

 Piv:=0; Iend:=0;
 For K:=1 to N do begin
  IPiv^.Put(K,pointer(K));
  H:=0; Ist:=Iend+1; Inc(Iend,M);
  For I:=Ist to Iend do H:=H+Sqr(PFloat(M1^.Get(I))^);
  Aux^.Put(K,@H);
  If H>Piv then begin
   Piv:=H; KPiv:=K
  end
 end;

 If Piv<=0 then begin
  IER:=-1; exit
 end;

 Sig:=Sqrt(Piv); Tol:=Sig*Abs(Eps);
 LM:=L*M; Ist:=-M;
 For K:=1 to N do begin
  Inc(Ist,M+1); Iend:=Ist+M-K; I:=KPiv-K;
  If I>0 then begin
   H:=PFloat(Aux^.Get(K))^;
   Aux^.Put(K,Aux^.Get(KPiv));
   Aux^.Put(KPiv,@H);
   ID:=I*M;
   For I:=Ist to Iend do begin
    J:=I+ID;
    H:=PFloat(M1^.Get(I))^;
    M1^.Put(I,M1^.Get(J));
    M1^.Put(J,@H)
   end
  end;

  If K>1 then begin
   Sig:=0;
   For I:=Ist to Iend do Sig:=Sig+Sqr(PFloat(M1^.Get(I))^);
   Sig:=Sqrt(Sig);
   If Sig<=Tol then begin
    IER:=K-1; exit
   end
  end;

  H:=PFloat(M1^.Get(Ist))^;
  If H<0 then Sig:=-Sig;
  IPiv^.Put(KPiv,pointer(PWord(IPiv^.Get(K))^));
  IPiv^.Put(K,pointer(KPiv));

  Beta:=H+Sig;
  M1^.Put(Ist,@Beta);
  Beta:=1/(Sig*Beta);
  J:=N+K;
  R:=-Sig;
  Aux^.Put(J,@R);
  If K<N then begin
   Piv:=0; Id:=0; Jst:=K+1; KPiv:=Jst;
   For J:=Jst to N do begin
    Inc(ID,M); H:=0;
    For I:=Ist to Iend do begin
     II:=I+ID;
     H:=H+PFloat(M1^.Get(I))^*PFloat(M1^.Get(II))^
    end;
    H:=Beta*H;
    For I:=Ist to Iend do begin
     II:=I+ID;
     R:=PFloat(M1^.Get(II))^-PFloat(M1^.Get(I))^*H;
     M1^.Put(II,@R)
    end;
    II:=Ist+ID;
    H:=PFloat(Aux^.Get(J))^-Sqr(PFloat(M1^.Get(II))^);
    Aux^.Put(J,@H);
    If H>Piv then begin
     Piv:=H; KPiv:=J
    end
   end
  end;

  J:=K;
  While J<=LM do begin
   H:=0; Iend:=J+M-K; II:=Ist;
   For I:=J to Iend do begin
    H:=H+PFloat(M1^.Get(II))^*PFloat(M2^.Get(I))^;
    Inc(II)
   end;
   H:=Beta*H;
   II:=Ist;
   For I:=J to Iend do begin
    R:=PFloat(M2^.Get(I))^-PFloat(M1^.Get(II))^*H;
    M2^.Put(I,@R);
    Inc(II)
   end;
   Inc(J,M)
  end
 end;

 IER:=0; I:=N; LN:=L*N;
 Piv:=1/PFloat(Aux^.Get(2*N))^;

 K:=N;
 While K<=LN do begin
  R:=Piv*PFloat(M2^.Get(I))^;
  X^.Put(K,@R);
  Inc(I,M);
  Inc(K,N)
 end;

 If N>1 then begin
  Jst:=(N-1)*M+N;
  For J:=2 to N do begin
   Dec(Jst,M+1);
   K:=2*N+1-J;
   Piv:=1/PFloat(Aux^.Get(K))^;
   Kst:=K-N;
   ID:=PWord(IPiv^.Get(Kst))^-Kst;
   Ist:=2-J;
   For K:=1 to L do begin
    H:=PFloat(M2^.Get(Kst))^;
    Inc(Ist,N); Iend:=Ist+J-2; II:=Jst;
    For I:=Ist to Iend do begin
     Inc(II,M);
     H:=H-PFloat(M1^.Get(II))^*PFloat(X^.Get(I))^
    end;
    I:=Ist-1;
    II:=I+ID;
    X^.Put(I,X^.Get(II));
    R:=Piv*H;
    X^.Put(II,@R);
    Inc(Kst,M)
   end
  end
 end;

 Ist:=N+1; Iend:=0;
 For J:=1 to L do begin
  Inc(Iend,M); H:=0;
  If M>N then begin
   For I:=Ist to Iend do H:=H+Sqr(PFloat(M2^.Get(I))^);
   Inc(Ist,M)
  end;

  Aux^.Put(J,@H)
 end
End;

Function Inpr(X,Y:PMatrix; L,IX,IY:byte; FirstX,FirstY:integer):extended;
Var Value:extended;
    I,J,Ixl:integer;
Begin
 Value:=0;
 I:=0; J:=0; Ixl:=IX*L-1;
 While I<=Ixl do begin
  Value:=Value+PFloat(X^.Get(I+FirstX))^*PFloat(Y^.Get(J+FirstY))^;
  Inc(I,IX); Inc(J,IY)
 end;
 Inpr:=Value
End;

Function Rfld(P:PMatrix; L,IP:byte; FirstP:integer):extended;
Label 5;
Var PM,T,R:extended;
    Ipl,I:integer;
Begin
 If L<>1 then begin
  PM:=0; Ipl:=IP*L+FirstP-1; I:=FirstP;
  While I<=Ipl do begin
   If Abs(PFloat(P^.Get(I))^)>PM then PM:=Abs(PFloat(P^.Get(I))^);
   Inc(I,IP)
  end;

  If PM>0 then begin
   I:=FirstP;
   While I<=Ipl do begin
    R:=PFloat(P^.Get(I))^/PM;
    P^.Put(I,@R);
    Inc(I,IP)
   end;
   T:=Sqrt(Inpr(P,P,L,IP,IP,FirstP,FirstP));
   If PFloat(P^.Get(FirstP))^<=0 then T:=-T;
   Rfld:=-T*PM;
   R:=PFloat(P^.Get(FirstP))^+T;
   P^.Put(FirstP,@R);
   PM:=Sqrt(PFloat(P^.Get(FirstP))^*T);
   I:=FirstP;
   While I<=Ipl do begin
    R:=PFloat(P^.Get(I))^/PM;
    P^.Put(I,@R);
    Inc(I,IP)
   end;
   exit
  end
 end;

 Rfld:=PFloat(P^.Get(FirstP))^;
 R:=0;
 P^.Put(FirstP,@R)
End;

Procedure Refl(P,X:PMatrix; L,N,IP,IX,JX:byte; FirstP,FirstX:integer);
Var Jxn,I,Ipl,J,K:integer; S,R:extended;
Begin
 Jxn:=JX*N+FirstX-1; Ipl:=IP*L+FirstP-1; J:=FirstX;
 While J<= Jxn do begin
  S:=Inpr(P,X,L,IP,IX,FirstP,J);
  K:=J; I:=FirstP;
  While I<=Ipl do begin
   R:=PFloat(X^.Get(K))^-S*PFloat(P^.Get(I))^;
   X^.Put(K,@R);
   Inc(K,IX); Inc(I,IP)
  end;
  Inc(J,JX)
 end
End;

Procedure Btd(Regim:byte; A,B:PMatrix);
Label 3,5;
Var L,L1,LL,M,N,K2,K,I,II,I1,J,Inco,K1:integer; R:extended;
Begin
 R:=0;
 B^.Put(1,@R);
 K2:=1; K:=Regim-1;
 M:=A^.Lines; N:=A^.Cols;
 L:=M+1-K;
 If L<=0 then goto 5;
 LL:=N; I:=1; II:=M; I1:=1; J:=1; Inco:=K;
 If M>=N then goto 3;

 While True do begin
  I1:=II; II:=I; I:=I1;
  If (Regim=2) or (I=1) then begin
   L1:=LL; LL:=L; L:=L1;
3: Inc(J,Inco);

   R:=Rfld(A,L,I,K);
   B^.Put(J,@R);
   K1:=K; K2:=K+II; L1:=LL-1;
  end
  else begin
   B^.Put(J-1,A^.Get(K1-1));
   I1:=1
  end;

  Dec(LL);
  If LL<=0 then goto 5;
  Inc(K,II);
  If L>1 then Refl(A,A,L,L1,I1,I,II,K1,K2);
 end;

5:
  If Regim<>2 then B^.Put(N+N,A^.Get(K2))
End;

Procedure Btdbk(Regim:byte; A,X:PMatrix; RegRefl1,RegRefl2,K:integer);
Var IA,IX,JX,J,JJ,L,LL,LLL,IXI,MP1:integer; M,N:byte;
Begin
 IA:=1; M:=A^.Lines; N:=A^.Cols;
 If Regim=4 then IA:=M;
 IX:=K; JX:=1;
 If RegRefl2<>2 then begin
  IX:=1; JX:=M;
  If Regim=4 then JX:=N else JX:=M
 end
 else begin
  IX:=K; JX:=1
 end;

 If M>N then begin
  L:=M; LL:=N
 end
 else begin
  L:=N; LL:=M
 end;

 J:=1; JJ:=1;
 If not (((Regim=2) and (M>=N)) or ((Regim=4) and (M<N))) then begin
  L:=LL-1; LL:=L-1; Inc(J,IX); Inc(JJ,IA)
 end
 else
  If M=N then Dec(LL);

 If LL>0 then begin
  MP1:=RegRefl1*(M+1); IXI:=IX*RegRefl1;
  If RegRefl1<>1 then begin
   LLL:=LL-1; L:=L-LLL; Dec(J,IXI*LLL); Dec(JJ,MP1*LLL)
  end;
  For LLL:=1 to LL do begin
   Refl(A,X,L,K,IA,IX,JX,JJ,J);
   Dec(L,RegRefl1); Inc(J,IXI); Inc(JJ,MP1)
  end
 end
End;

Procedure Grs(Regim:byte; B:PMatrix; N,Ind1,IndL:byte;
              Var Smax,Smin:extended);
Var
 Inco,N2,J,I:integer;
 P,R,Q,Z:extended;
Begin
 Inco:=Regim-1;
 N2:=N*2;
 R:=0;
 B^.Put(1,@R);
 R:=0; P:=0; Smax:=PFloat(B^.Get(N2))^;
 If Regim<>2 then Smin:=Smax;
 J:=N2+1; I:=1;

 While I<=N2 do begin
  Dec(J,Inco);
  Q:=Abs(PFloat(B^.Get(J))^); Z:=P+Q;
  If Regim<>2 then begin
   R:=PFloat(B^.Get(1+J))^; Smin:=EMin(SMin,R-Z)
  end;
  SMax:=EMax(SMax,R+Z); P:=Q;
  Inc(I,Inco)
 end;

 If Regim=2 then begin
  Smin:=0;
  If IndL=1 then
   For I:=2 to N2 do Smin:=EMax(Smin,Abs(PFloat(B^.Get(I))^));
  If IndL=N then begin
   I:=2;
   While I<=N2 do begin
    Smax:=EMin(Smax,Abs(PFloat(B^.Get(I))^));
    Inc(I,2)
   end
  end
 end
End;

Procedure Sev(Regim:byte; B:PMatrix; N,L:byte;
              Ind:PMatrixInt;
              Smax,Smin:PMatrix; ErrAbs:extended);
Label 5,6,10,11;
Var
 Inco,Jump:byte;
 N2,I,J,M,J1,L1,J2:integer;
 R,Z,X,Y,P,Q:extended;
Begin
 Inco:=Regim-1; N2:=N*2;
 P:=0;
 B^.Put(1,@P);
 If L<=0 then begin
  Z:=PFloat(Smax^.Get(1))^;
  Jump:=1; goto 6
 end;

 X:=PFloat(SMin^.Get(1))^; Y:=PFloat(Smax^.Get(1))^;
 For I:=1 to L do begin
  Smin^.Put(I,@X); Smax^.Put(I,@Y)
 end;

 Jump:=8; J:=1;
 While True do begin
5:
  Z:=(X+Y)/2;
  If not ((Y-X<=ErrAbs) or ((Z<=X) or (Y<=Z))) then begin
6:
   M:=0; Q:=2; I:=1;
   While I<=N2 do begin
    P:=PFloat(B^.Get(I))^/Q; Q:=Z-P*PFloat(B^.Get(I))^;
    If Regim=3 then Q:=Q-PFloat(B^.Get(I+1))^;
    If Abs(Q)<Epsmin then Q:=-Epsmin;
    If Q<0 then Inc(M);
    Inc(I,Inco)
   end;

   Case Jump of
    1:begin
       Ind^.Put(1,pointer(M+1)); Z:=PFloat(Smin^.Get(1))^;
       Jump:=2; goto 6
      end;

    2:begin
       Ind^.Put(2,pointer(M)); exit
      end
   end;

   If PWord(Ind^.Get(J))^>M then begin
    Y:=Z; goto 5
   end;

   J1:=J; L1:=L;
10:
   If J1<>L then begin
    J2:=J1+1;
    If PWord(Ind^.Get(J2))^<=M then begin
11:  If J2>(J1+L1) div 2 then I:=J2 else I:=(J1+L1) div 2;
     If M<PWord(Ind^.Get(I))^ then begin
      L1:=I; goto 11
     end;
     J1:=I; goto 10
    end;
    R:=EMin(PFloat(Smax^.Get(J2))^,Z);
    Smax^.Put(J2,@R)
   end;

   X:=Z;
   R:=EMax(PFloat(Smin^.Get(J1))^,Z);
   If J1>J then Smin^.Put(J1,@R)
  end

  else begin
   Smin^.Put(J,@X); SMax^.Put(J,@Y);
   If J=L then exit;
   Inc(J);
   Y:=EMin(Y,PFloat(Smax^.Get(J1))^); X:=PFloat(Smin^.Get(L))^;
   If J<>L then begin
    J1:=L; L1:=L-1;
    For I:=J to L1 do begin
     Dec(J1);
     X:=EMax(X,PFloat(Smin^.Get(J1))^);
     Smin^.Put(J1,@X)
    end
   end
  end
 end
End;

Procedure Sol(NEntry:byte; A,F,X:PMatrixF; Var B:PMatrixF;
              EAB:longint; Var EX:integer; Var Cond:extended;
              Var Error:integer);
Label 4;
Var BLen,I,J,K:integer; N:byte;
    Smax,Smin:PHeapMatrixFG;
    Sma,Smi,R:extended;
    Ind:PHeapMatrixInt;
Begin
 New(Smax,Init(2,1));
 New(Smin,Init(2,1));
 New(Ind,Init(2,1));

 N:=A^.Lines;

 If NEntry in [1,3] then begin
  If A^.Lines<A^.Cols then BLen:=2*A^.Lines
  else BLen:=2*A^.Cols;
  B:=New(PHeapMatrixFG,Init(BLen,1))
 end;

 Case NEntry of
  1:begin
     A^.NormalizePower(0);
     EAB:=A^.GetNormPower;
     Btd(2,A,B);
    end;

  2:EAB:=0;

  4:goto 4
 end;

 B^.NormalizePower(0);
 EX:=B^.GetNormPower;
 Inc(EAB,EX);

 Grs(2,B,N,1,N,Sma,Smi);
 SMax^.Put(1,@Sma);
 Smin^.Put(1,@Smi);

 Ind^.Put(1,pointer(1)); Ind^.Put(2,pointer(N));

 Sev(2,B,N,2,Ind,Smax,Smin,Epsmin);
 If PFloat(Smin^.Get(2))^<=Eps*PFloat(Smax^.Get(1))^ then Error:=-1
 else begin
  Cond:=PFloat(Smax^.Get(1))^/PFloat(Smin^.Get(2))^;

4:
  F^.NormalizePower(0);
  EX:=F^.GetNormPower;
  If NEntry<=2 then Btdbk(2,A,F,1,1,1);

  J:=N;
  R:=PFloat(F^.Get(J))^/PFloat(B^.Get(J*2))^;
  X^.Put(J,@R);

  If N>1 then
   For I:=2 to N do begin
    K:=J; Dec(J);
    R:=(PFloat(F^.Get(J))^-PFloat(B^.Get(J+K))^*
     PFloat(X^.Get(K))^)/PFloat(B^.Get(J*2))^;
    X^.Put(J,@R)
   end;

  If NEntry<3 then Btdbk(4,A,X,-1,1,1);

  Dec(EX,EAB);
  X^.SetNormPower(EX);
  X^.NormalizePower(1);
  EX:=X^.GetNormPower;
  Error:=0;
 end;

 Dispose(Smax,Done);
 Dispose(Smin,Done);
 Dispose(Ind,Done)
End;

Procedure EXS(I123:byte; N:integer; B,S:PMatrixF; ES:PMatrixInt;
              V:extended);
Label 3,4;
Var
 N1,Ink,I,J,JJ,Ec0,Ec1,Ec2,Es1,Es2,Ep,Eq,Et,E:integer;
 c0,c1,c2,s1,s2,p,q,t,d1,d2,R:extended; L:boolean;
Begin
 N1:=N-1;
 If N1<=0 then exit;
 Ink:=1;
 If I123=3 then Ink:=2;
 L:=False;
 J:=1; JJ:=0; c1:=1; Ec1:=0;
 If I123<>3 then begin
  c0:=1; Ec0:=0; N1:=N1*2
 end;
 For I:=1 to N1 do begin
  If I123=3 then begin
   t:=c1; Et:=Ec1
  end
  else
   If I>1 then begin
3:
    t:=q*c0;
    Et:=Eq+Ec0; c0:=c1; Ec0:=Ec1
   end;
4:
  Inc(JJ);
  Q:=PFloat(S^.Get(JJ))^;

  If not L then begin
   L:=Q=0;
   If L then goto 4
  end;
  If I123<=1 then Eq:=PWord(ES^.Get(JJ))^
  else Q:=GTexp(Q,Eq);
  Inc(J,Ink);
  P:=GTExp(PFloat(B^.Get(J))^,Ep);
  Dec(Eq,Ep);
  If not L then Q:=Q/P
  else begin
   Q:=P/Q; Eq:=-Eq
  end;
  If (I123<>3) and (J<=2) then goto 3;
  T:=GTexp(T*Q,E);
  Inc(Et,EQ+E);
  E:=MaxI(0,ET);
  s2:=Chexp(1,-E);
  c2:=Chexp(T,ET-E);
  c2:=Sqrt(s2*s2+c2*c2);
  s2:=GTExp(1/c2,Es2);
  Dec(Es2,E);
  c2:=GTExp(T/c2,Ec2);
  Inc(Ec2,ET-E);
  If I123=3 then begin
   d1:=d2;
   d2:=Chexp(P*T*C1,EP+ET+Ec1)
  end;
  R:=Chexp(T,MinI(Et,MaxExp));
  S^.Put(I,@R);
  If I>1 then begin
   R:=Chexp(P/S2*S1,EP-Es2+Es1);
   B^.Put(J-2,@R);
   If I123=3 then begin
    R:=PFloat(B^.Get(J-1))^-D1+D2;
    B^.Put(J-3,@R)
   end
  end;
  s1:=s2; Es1:=Es2;
  c1:=c2; Ec1:=Ec2
 end;

 If I123=3 then begin
  Inc(J);
  R:=PFloat(B^.Get(J))^-D2;
  B^.Put(J-2,@R);
  B^.Put(J,@V)
 end
 else begin
  R:=Chexp(P/c1*c0,Ep-Ec1+Ec0);
  B^.Put(J,@R)
 end;
 R:=0;
 B^.Put(J-1,@R)
End;

Procedure EXSbk(I234:byte; L:integer; S:PMatrixF; I,LR12,M,N:integer;
                X:PMatrixF; Offs1,Offs2:integer);
Var
 Ink,Ix,Jx,K,Jxk1,J,JJ,JJJ,LJ,J1,J2:integer;
 Cj,Sj,P,Q,R:extended;
Begin
 If L<=0 then exit;
 Ink:=1;
 If I234<>3 then Ink:=2;
 Ix:=1; Jx:=M; K:=N;
 If LR12<>1 then begin
  Ix:=M; Jx:=1; K:=M
 end;
 Jxk1:=Jx*(K-1);
 JJ:=1; J:=1;
 If I234=2 then J:=2;
 If I<>1 then begin
  Ink:=-Ink; Ix:=-Ix; Dec(JJ,L*Ix); Dec(J,(L-1)*Ink)
 end;
 For LJ:=1 to L do begin
  Sj:=1;
  Cj:=PFloat(S^.Get(J+Offs1))^;
  Q:=Abs(Cj);
  If Q>Sj then begin
   Sj:=Sj/Q; Cj:=Cj/Q
  end;
  Q:=1/Sqrt(Sj*Sj+Cj*Cj);
  Sj:=Sj*Q;
  Cj:=Cj*Q;
  JJJ:=JJ+Jxk1;
  J1:=JJ;
  While J1<=JJJ do begin
   J2:=J1+Ix;
   P:=PFloat(X^.Get(J1+Offs2))^;
   Q:=PFloat(X^.Get(J2+Offs2))^;
   R:=Cj*P-Sj*Q;
   X^.Put(J1+Offs2,@R);
   R:=Sj*P+Cj*Q;
   X^.Put(J2+Offs2,@R);
   Inc(J1,JX)
  end;
  Inc(JJ,Ix);
  Inc(J,Ink)
 end
End;

Const
{ Ovflo=1.5E4930;
 Undflo=3E-4930;}
 Eps=1E-17;
 Epsmin=1E-17;

Procedure ST1(N:word; B:PMatrixF; Ind:integer; Smax,Smin:extended;
 S:PMatrixF; ES:PMatrixInt; Errel:double);
Label 2,5,7,8,10,14,19,21;
Var
 N2,I,J,K,KK,Mx,My,Mz,Nx,Ny,Nz,Esmax,Esmin,Ep,Eq,Et,Ez,E:integer;
 P,Q,T,Z,R:extended; Jump:word; L0:boolean;
Begin
 N2:=N*2;
 R:=Epsmin;
 For I:=2 to N2 do
  If Abs(PFloat(B^.Get(I))^)<Epsmin then B^.Put(I,@R);
 If Smax<=0 then Smax:=2;
 Esmax:=0; Esmin:=0;
 Nx:=0; Ny:=N2; T:=Eps; Nz:=Ny;
 Jump:=3;

2:
 Smax:=GTExp(Smax,E);
 Inc(Esmax,E);
 Z:=Smax; Ez:=Esmax;

10:
 Mz:=1; K:=1+Nz;
 S^.Put(K,@Z);
 ES^.Put(K,pointer(Ez));
 For I:=2 to N2 do begin
  P:=GTExp(PFloat(B^.Get(I))^,Ep);
  Q:=GTExp(P/PFloat(S^.Get(K))^*P,E);
  Eq:=Ep*2-PWord(ES^.Get(K))^+E;
  E:=MaxI(Ez,Eq);
  Q:=CHExp(Z,EZ-E)-CHExp(Q,EQ-E);
  If Abs(Q)<Epsmin then Q:=-Epsmin;
  Inc(K);
  R:=GTExp(Q,EQ);
  S^.Put(K,@R);
  ES^.Put(K,pointer(EQ+E));
  If Q<0 then Inc(Mz)
 end;
 If Jump=3 then begin
  If MZ>Ind then begin
   Smax:=Smax*(1+T);
   T:=T*2;
   goto 2
  end;
  My:=Mz; T:=Eps; Nz:=Nx;
  Jump:=6;
5:
  L0:=Smin<=0;
  If not L0 then begin
   Smin:=GTExp(Smin,E);
   Inc(Esmin,E);
   Z:=Smin; Ez:=Esmin;
   goto 10
  end;
7:
  Mx:=Mz;
  Nz:=N2*2;
  Jump:=12;
8:
  If not L0 then begin
   Z:=CHExp(Smin,Esmin-Esmax);
   If Smax-Z<=Errel then goto 14;
   Z:=Z+Smax;
   Ez:=Esmax
  end;
  Z:=GTExp(Z/2,E);
  Inc(Ez,E);
  If L0 then goto 10;
  If (EZ<Esmin) or ((EZ=Esmin) and (Z<=Smin)) then goto 14;
  If (EZ>Esmax) or ((EZ=Esmax) and (Smax<=Z)) then goto 14;
 end
 else
 If Jump=6 then begin
  If Ind<Mz then goto 7;
  Smin:=Smin*(1-T);
  T:=T*2;
  goto 5
 end
 else
 If Jump=12 then begin
  If Ind>=Mz then begin
   Smax:=Z; Esmax:=EZ; My:=Mz; I:=Ny; Ny:=Nz; NZ:=I;
   goto 8
  end;
  Smin:=Z; Esmin:=EZ; Mx:=Mz; I:=Nx; Nx:=Nz; Nz:=I; L0:=False;
  goto 8
 end;

14:
 K:=N2; Z:=Smax; Ez:=Esmax; T:=0; ET:=EZ;
 For I:=2 to N2 do begin
  If PFloat(S^.Get(K+NX))^<0 then Dec(MX);
  If PFloat(S^.Get(K+NY))^<0 then Dec(MY);
  E:=MaxI(EZ,ET);
  Q:=CHExp(Z,EZ-E)-CHExp(T,ET-E);
  If Abs(Q)<Epsmin then Q:=-Epsmin;
  Q:=GTExp(Q,EQ);
  Inc(EQ,E);
  P:=GTExp(PFloat(B^.Get(K))^,EP);
  T:=GTExp(P/Q*P,E);
  ET:=EP*2-EQ+E;
  Dec(KK);
  If MX=Ind then begin
   J:=NX;
   E:=MaxI(ET,PWord(ES^.Get(KK+J))^);
   If CHExp(T,ET-E)<CHExp(PFloat(S^.Get(KK+J))^,PWord(ES^.Get(KK+J))^-E)
   then goto 19;
  end;
  If MY=Ind then begin
   J:=NY;
   E:=MaxI(ET,PWord(ES^.Get(KK+J))^);
   If CHExp(PFloat(S^.Get(KK+J))^,PWord(ES^.Get(KK+J))^-E)<
   CHExp(T,ET-E) then goto 19
  end;
  If Q<=0 then begin
   Inc(MX); Inc(MY)
  end;
  S^.Put(K+NZ,@Q);
  ES^.Put(K+NZ,pointer(EQ));
  K:=KK
 end;
 goto 21;

19:
 For I:=1 to KK do begin
  S^.Put(I,S^.Get(I+J));
  ES^.Put(I,pointer(PWord(ES^.Get(I+J))^))
 end;

21:
 R:=0;
 S^.Put(K,@R);
 Inc(K);
 If N2>=K then
  For I:=K to N2 do begin
   S^.Put(I,S^.Get(I+NZ));
   ES^.Put(I,pointer(PWord(ES^.Get(I+NZ))^))
  end;
 Smax:=CHexp(Smax,Esmax);
 Smin:=CHexp(Smin,Esmin);
End;

Function PSol(Entry:byte; A,F:PMatrixF; Rank:byte; Var EX:integer;
 X:PMatrixF; Var D,Cond,Teta:extended; EAB:integer; Var B:PMatrixF;
 SVal:PHeapMatrixFG):integer;

Var I,II,J,K,L,Lrank,Lrank1,Lmrank,IR,IL,M,N:integer;
    T1,T2,R,R1:extended; S,UR,UL,T:PHeapMatrixFG; P:pointer;
    Ind,ET:PHeapMatrixInt;

 Procedure Done;
 begin
  Dispose(UL, Done);
  Dispose(UR, Done);
  Dispose(T, Done);
  Dispose(Ind, Done);
  Dispose(ET, Done);
  If Entry<>5 then Dispose(B, Done)
 end;

Begin
 M:=A^.Lines; N:=A^.Cols;
 L:=MinI(M,N);
 Lrank:=MinI(L,Rank);
 Lrank1:=Lrank+1;
 Lmrank:=L-Lrank;

 I:=M-Rank;
 If I<=0 then I:=1;
 UL:=New(PHeapMatrixFG,Init(M,I));
 I:=N-Rank;
 If I<=0 then I:=1;
 UR:=New(PHeapMatrixFG,Init(N,I));
 Ind:=New(PHeapMatrixInt,Init(L,1));
 ET:=New(PHeapMatrixInt,Init(6*L,1));
 T:=New(PHeapMatrixFG,Init(6*L,1));

 If Entry<>5 then
  B:=New(PHeapMatrixFG,Init(2*L,1));

 Case Entry of
  1:begin
   A^.NormalizePower(0);
   EAB:=A^.GetNormPower;
   BTD(2,A,B);
  end;
  5:EAB:=0;
  4,8:begin
   R:=0;
   R1:=1;
   If L>Lrank then begin
    J:=Lmrank;
    For K:=Lrank1 to L do begin
     II:=K-1;
     For I:=1 to II do begin
      T^.Put(2*I-1,UR^.Get2(I,J));
      T^.Put(2*I,UL^.Get2(I,J));
      UR^.Put2(I,J,@R);
      UL^.Put2(I,J,@R);
     end;
     UR^.Put2(K,J,@R1);
     UL^.Put2(K,J,@R1);
     IR:=K+1;
     For I:=IR to N do UR^.Put2(I,J,@R);
     For I:=IR to M do UL^.Put2(I,J,@R);
     I:=K-Lrank;
     EXSbk(4,II,T,-1,1,N,I,UR,0,(J-1)*N);
     EXSbk(2,II,T,-1,1,M,I,UL,0,(J-1)*M);
     Dec(J)
    end
   end;
   K:=Abs(M-N);
   If K>0 then
    If M<=N then
     For II:=1 to K do begin
      J:=Lmrank+II;
      For I:=1 to N do UR^.Put2(I,J,@R);
      UR^.Put2(L+II,J,@R1)
     end
    else
     For II:=1 to K do begin
      J:=Lmrank+II;
      For I:=1 to M do UL^.Put2(I,J,@R);
      UL^.Put2(L+II,J,@R1)
     end;
   If Entry<=4 then begin
    If Lrank<N then BTDbk(4,A,UR,-1,1,N-Lrank);
    If Lrank<M then BTDbk(4,A,UL,-1,1,M-Lrank)
   end;
   PSol:=1;
   Done;
   exit
  end
 end;

 Case Entry of
  1,5:begin
   B^.NormalizePower(0);
   EX:=B^.GetNormPower;
   Inc(EAB,EX);
   GRS(2,B,N,1,L,R,R1);
   SVal^.Put(1,@R1);
   SVal^.Put(L+1,@R);
   For I:=1 to L do Ind^.Put(I,pointer(I));
   S:=New(PHeapMatrixFG,Init(L,1));
   P:=S^.BM;
   S^.BM:=@SVal^.BM^[L];
   Sev(2,B,L,L,Ind,S,SVal,Epsmin);
   S^.BM:=P;
   Dispose(S, Done);
   Ind^.Put(1,pointer(L))
  end
 end;

 Case Entry of
  1,3,5,7:begin
   If L>Rank then D:=PFloat(SVal^.Get(Lrank1))^
   else D:=0;
   D:=(PFloat(SVal^.Get(Lrank))^-D)/PFloat(SVal^.Get(1))^;
   If D<=Eps then begin
    PSol:=-1; Done; exit
   end;
   D:=1/D;
   Cond:=PFloat(SVal^.Get(1))^/PFloat(SVal^.Get(Lrank))^;
   If PWord(Ind^.Get(1))^>Lrank then begin
    IR:=-1; IL:=0;
    If M<N then begin
     IL:=-1; IR:=0
    end;
    K:=PWord(Ind^.Get(1))^;
    II:=L+1-K;
    For J:=II to Lmrank do begin
     ST1(K,B,K,PFloat(SVal^.Get(K+L))^,PFloat(SVal^.Get(K))^,T,ET,Epsmin);
     EXS(1,K,B,T,ET,0);
     Dec(K);
     For I:=1 to K do begin
      UR^.Put2(I,J,T^.Get(IR+I*2));
      UL^.Put2(I,J,T^.Get(IL+I*2))
     end;
    end;
    Ind^.Put(1,pointer(Lrank))
   end;
  end
 end;

 IL:=L-PWord(Ind^.Get(1))^;
 F^.NormalizePower(0);
 EX:=F^.GetNormPower;
 If Entry<=4 then BTDbk(2,A,F,1,1,1);
 For J:=1 to IL do EXSbk(3,L-J,UL,1,1,M,1,F,(J-1)*M,0);
 T1:=Sqrt(Inpr(F,F,Lrank,1,1,1,1));
 T2:=0;
 If Lrank<M then T2:=Sqrt(Inpr(F,F,M-Lrank,1,1,Lrank1,Lrank1));
 If T1<=T2*Eps then begin
  PSol:=-2; Done; exit
 end;
 Teta:=T2/T1;
 I:=-1; J:=Lrank;
 If M<N then begin
  I:=1; J:=1
 end;
 R:=PFloat(F^.Get(J))^/PFloat(B^.Get(J*2))^;
 X^.Put(J,@R);
 For K:=2 to Lrank do begin
  II:=J; Inc(J,I);
  R:=(PFloat(F^.Get(J))^-PFloat(B^.Get(J+II))^*PFloat(X^.Get(II))^)/
     PFloat(B^.Get(J*2))^;
  X^.Put(J,@R)
 end;
 R:=0;
 If N>Lrank then
  For I:=Lrank1 to N do X^.Put(I,@R);
 If IL>0 then begin
  J:=IL;
  II:=PWord(Ind^.Get(1))^+1;
  For K:=II to L do begin
   EXSbk(3,K-1,UR,-1,1,N,1,X,(J-1)*N,0);
   Dec(J)
  end;
 end;

 If Entry<4 then BTDbk(4,A,X,-1,1,1);
 Dec(EX,EAB);
 X^.SetNormPower(EX);
 X^.NormalizePower(1);
 EX:=X^.GetNormPower;
 PSol:=1;
 Done
End;


End.

