{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Def2x2;

Interface

Const

 { Term types }
 { !!!   祭 ⠭   冷 }

 opNull       = 0 ;
 opNil        = 0 ;
 opBlank      = 2 ;
 opLBra       = 3 ; { ( }
 opRBra       = 4 ; { ) }
 opLBrack     = 5 ; { [ }
 opOutSign    = 6 ; { @ }
 opBadLog     = 7 ;
 opV          = 8 ; { ! }
 opPoint      = 9 ; { . }

 opConst      = 10 ;
 opFPar       = opConst+1 ;
 opFUknown    = opConst+2 ;
 opNewVar     = opConst+3 ;
 opFConst     = opConst+4 ;

 opArrayVar   = opConst+6 ;
 opPolinom    = opConst+7 ;
 opStrArrVar  = opConst+8 ;
 opMatrixVar  = opConst+9 ;
 opAnyArrVar  = opConst+10 ;

 opIf         = 23 ;
 opWhile      = opIf+1 ;
 opRepeat     = opIf+2 ;
 opElse       = opIf+4 ;
 opSemiColon  = opIf+5 ;
 opEndData    = opIf+6 ;
 opEndWhile   = opIf+7 ;
 opEndIf      = opIf+8 ;
 opEndElse    = opIf+9 ;
 opEndFunc    = opIf+10 ;
 opUntil      = opIf+11 ;
 opEndSwitch  = opIf+12 ;
 opEndCase    = opIf+13 ;
 opOf         = opIf+14 ;
 opEnd        = opIf+15 ;

 opColon      = opIf+16 ; { : }
 opRBrack     = opIf+17 ; { ] }
 opAssign     = opIf+18 ; { = }
 opDo         = opIf+19 ; { do }
 opThen       = opIf+20 ; { then }
 opRel        = opIf+21 ;
 opLogic      = opIf+22 ;
 opComma      = opIf+23 ; { , }

 opFunc0      = 47 ;
 opFunc1      = 48 ;
 opFunc2      = 49 ;

 opArrayDef   = 50 ;
 opPolinomDef = opArrayDef+1 ;
 opMatrixDef  = opArrayDef+2 ;
 opFuncDef    = opArrayDef+3 ;
 opProcDef    = opArrayDef+4 ;
 opStringDef  = 55 ; { string }

 opExtern     = 56 ;
 opBreak      = 57 ;
 opContinue   = opBreak+1 ;
 opExit       = opBreak+2 ;
 opBegin      = 60 ;
 opYetDone    = 61 ;
 opFunc       = 62 ;

 opStringConst= 63 ;
 opSPar       = opStringConst+1;
 opSUknown    = opStringConst+2;
 opSConst     = opStringConst+3;

 opSimm       = 70 ; { Simmetr }
 opDiag       = 71 ; { Diag    }
 opOut        = 72 ; { Out     }
 opParDef     = 73 ; { Par     }
 opText       = 74 ; { ' }
 opPrint      = 76 ;

 opStrConcat  = 78 ;
 opMultiVar   = 79 ;
 opFloatDef   = 80 ;
 opCompFunc   = 81 ;
 opCase       = 82 ;
 opUses       = 83 ;
 opLibDef     = 84 ;
 opResident   = 85 ;
 opObject     = 86 ;
 opExport     = 88 ;
 opInclude    = 89 ;
 opConstDef   = 90 ;

 opObjectType = 91 ;
 opObjectRef  = 92 ;
 opUserVar    = 93 ;
 opUserPar    = 94 ;
 opUserType   = 95 ;
 opAs         = 96 ;
 opDefine     = 97 ;
 opVarDef     = 98 ;
 opNextCase   = 99 ;

 opUserType1  = 101; { 101..150 - ⨯ 짮⥫ }
 opUserType2  = 150;
 opObjType1   = 201; { 201..600 - ꥪ 짮⥫ }
 opObjType2   = 500;
 opObjType3   = 900;
 opObjType4   = 3000;
 opObjType5   = 3500;

 opMethod     = 996;
 opMethodDef  = 997;
 opObjectDef  = 998;
 opFieldAtr   = 999;
 opRefPar     = 1000;
 opRefString  = 1001;
 opRefUser    = 1002;
 opRefArrayVar = 1003;
 opRefStrArrVar= 1004;
 opRefObject   = 1005;
 opRefObjectRef= 1006;

 opParProc    = $0400-3 ;
 opParFunc    = $0400-2 ;
 opParStrFunc = $0400-1 ;
 {  ⠭ 10-   >opParStrFunc }
 opUserFunc      = $0400 ;
 opStringFunc    = $1400 ;
 opDirectFunc    = $2400 ;
 opDirectStrFunc = $3400 ;
 opUserProc      = $4400 ;
 opDirectProc    = $5400 ;
 opLib           = $6400 ;

Const
 utfByPar =  1;

 wmpUknown           = opUserType1-9;
 wmpFloatMultiPar    = opUserType1-8;
 wmpStrMultiPar      = opUserType1-7;
 wmpArrayMultiPar    = opUserType1-6;
 wmpUserTypeMultiPar = opUserType1-5;
 wmpRes0             = opUserType1-4;
 wmpRes1             = opUserType1-3;
 wmpRes2             = opUserType1-2;
 wmpRes3             = opUserType1-1;
 wmpUserType1        = opUserType1;
 wmpUserType2        = opUserType2;
 wmpObject           = wmpUserType2+1;

 dctProc      = opUserType1-8;
 dctFunc      = opUserType1-7;
 dctObjType   = opUserType1-6;
 dctFloat     = opUserType1-5;
 dctString    = opUserType1-4;
 dctAnyArray  = opUserType1-3;
 dctArray     = opUserType1-2;
 dctStrArray  = opUserType1-1;
 dctUserType1 = opUserType1;
 dctUserType2 = opUserType2;
 dctObjType1  = opObjType1;
 dctObjType2  = opObjType5;
 dctObject    = dctUserType2+1;
 dctObjRef    = dctUserType2+2;

Type
 TFuncOptions=set of (foAsProperty,foSimplified);
 TMultiExprType=wmpUknown..wmpObject;
 OpsType=opNull..opLib;
 TUserVarType=opUserType1..opUserType2;
 TObjVarType=opObjType1..opObjType5;
 FArrayType=(atFloat,atString);
 TReturnType=(rtFloat,rtString);
 TPasReturnType=(prtByte,prtChar,prtBoolean,prtInt,prtWord,prtLong,prtPointer,
    prtDouble,prtExtended,prtString);
 TPasParType=(pptByte,pptChar,pptBoolean,pptInt,pptWord,pptLong,pptPointer,pptDouble,
    pptExtended,pptString,pptArray,pptObject,pptObjectRef,pptObjectType);
 T2x2Type=dctObjType..dctObjType2;
 TObjFieldType=dctFloat..dctObjRef;
 TRunControl=(rbBreak,rbContinue,rbExit);
 TSubrType=(wcFunc,wcProc);
 TSubrParType=TSubrType;
 TMethodType=(mtFloatFunc,mtStrFunc,mtProc);
 TStackOperation=(pctE2I,pctE2W,pctPE2I,pctI2E,pctE2L,pctPE2L,pctL2E,pctE2D,
    pctPE2D,pctD2E,pctE2E,pctP2P,pctPP2P);
 T2x2ProgType=(pt2x2Program,pt2x2Library);
 T2x2Options=set of (coCompLib,coAutoUnload);
 T2x2States=set of (csCompiling,csCompiled,csEvaluating,csNotActual,csDonePerfom);
 TModuleType=(mtMain,mtLibrary,mtInclude);
 TSwitchDirection=(sdForward,sdBackward);

Const
 rtDontCare=rtFloat;
 prtDontCare=prtByte;

Const
 { Block types }

 wbGlobal     = 0   ;
 wbIf         = 1   ;
 wbWhile      = 2   ;
 wbRepeat     = 3   ;
 wbArrayDef   = 7   ;
 wbPolinomDef = 8   ;
 wbMatrixDef  = 9   ;
 wbElse       = 12  ;
 wbCase       = 13  ;
 wbFuncDef    = $80 ;

 { Boolean types }

 rtG  = 0; { >  }
 rtGE = 1; { >= }
 rtL  = 2; { <  }
 rtLE = 3; { <= }
 rtE  = 4; { =  }
 rtNE = 5; { <> }
 rtIsZero = 6; { =0 }
 rtIsOne  = 7; { =1 }
 LastrtFloat=rtIsOne;

 rtsG  =  LastrtFloat+1; { >  }
 rtsGE =  LastrtFloat+2; { >= }
 rtsL  =  LastrtFloat+3; { <  }
 rtsLE =  LastrtFloat+4; { <= }
 rtsE  =  LastrtFloat+5; { =  }
 rtsNE =  LastrtFloat+6; { <> }

 { Logic types }

 ltAnd = 0 ; { AND }
 ltOr  = 1 ; { OR  }
 ltNot = 2 ; { NOT }
 ltXor = 3 ; { XOR }

 { Expression types }

 etNull          = 0            ;
 etFormula       = 1            ;  { ᫮ - ᢠ }
 etIf            = 2            ;  { 横 While      }
 etWhile         = 3            ;  { 横 If         }
 etRepeat        = 4            ;  { 横 Repeat     }
 etArrayCell     = 5            ;  { - ᢠ - ᫮ ᨢ }
 etStrFormula    = 6            ;  { ப - ᢠ }
 etArrayDef      = wbArrayDef   ;  { 7, ᠭ ᨢ  }
 etPolinomDef    = wbPolinomDef ;  { 8, ᠭ  }
 etMatrixDef     = wbMatrixDef  ;  { 9 }
 etLogic         = 10           ;  { ᪮ ࠦ }
 etBool          = 11           ;  { ࠦ ⭮襭 (ࠢ) }
 etElse          = wbElse       ;  { 12,  else }
 etObjBool       = 14           ;
 etPrint         = 15           ;  {  Print }
 etStrArrayCell  = 16           ;  { - ᢠ - ப ᨢ }
 etCaseNext      = 17           ;
 etObjectDef     = 18           ;
 etProcDef       = 20           ;  { ᠭ 楤 }
 etProc          = 21           ;
 etFuncProp      = 27           ;  { - ᢠ 祭 --property }
 etCompFunc      = 30           ;  { IsTrue, IsFalse }
 etCase          = 31           ;
 etObjFormula    = 32           ;
 etRefFormula    = 33           ;
 etRefStrFormula = 34           ;
 etObjRefAssignFormula = 36     ;
 etBreak         = opBreak      ;  { 56 }
 etContinue      = opContinue   ;  { 57 }
 etExit          = opExit       ;  { 58 }
 etText          = opText       ;  { 74 }
 etFuncDef       = wbFuncDef    ;  { $80, ᠭ 㭪樨 }

 AropetDel=opArrayDef-etArrayDef; { ࠧ opArrayDef-etArrayDef }
 OpArDel=opArrayDef-opArrayVar;

Type
 ExprType=etNull..etFuncDef;

Const

 { function types }

 f1Neg    = 0  ;
 f1Sin    = 1  ;
 f1Cos    = 2  ;
 f1Tg     = 3  ;
 f1Arcsin = 4  ;
 f1Arccos = 5  ;
 f1Arctg  = 6  ;
 f1Abs    = 7  ;
 f1Sqr    = 8  ;
 f1Sqrt   = 9  ;
 f1Rad    = 10 ;
 f1Grad   = 11 ;
 f1Ln     = 12 ;
 f1Lg     = 13 ;
 f1Exp    = 14 ;
 f1Sign   = 15 ;
 f1Frac   = 16 ;
 f1Round  = 17 ;
 f1Trunc  = 18 ;
 f1Error  = 20 ;

 { math operation types }

 moPlus  = f1Error+1   ; { + }
 moMinus = f1Error+2   ; { - }
 moMult  = f1Error+3   ; { * }
 moDiv   = f1Error+4   ; { / }
 moLDiv  = f1Error+5   ; { div }
 moLMod  = f1Error+6   ; { mod }
 moPower = f1Error+7   ; { ^ }

 FuncIndex2x2=100; { max  -, १ࢨ஢  2x2;
                     - -   訥 100 }

 { errors }

 teOK               =  0 ;
 teSyntax           =  1 ;
 teIncorrectChar    =  2 ;
 teMathExpected     =  3 ;
 teInvNameLen       =  4 ;
 teDoubleName       =  5 ;
 teRBraExpected     =  6 ;
 teLBraExpected     =  7 ;
 teEIE              =  8 ;
 teUnexpectedEnd    =  9 ;
 teLBrackExpected   =  10;
 teRBrackExpected   =  11;
 teEndExpected      =  12;
 teUknownVar        =  13;
 teBraUnnecessary   =  14;
 teBraFromLogic     =  15;
 teRelExpected      =  16;
 teThenExpected     =  17;
 teDoExpected       =  18;
 teEndElseExpected  =  19;
 teEndIfExpected    =  20;
 teEndWhileExpected =  21;
 teAssignExpected   =  24;
 teNoData           =  25;
 teAmperExpected    =  26;
 teResword          =  27;
 teFirstNumber      =  28;
 teEIS              =  29;
 teLocArrDef        =  30;
 teLocPolDef        =  teLocArrDef+1;
 teLocMatrixDef     =  teLocPolDef+1;
 teLocFuncDef       =  33;
 teOriginNameExpected = 34;
 teArrayNameExpected  = 35;
 tePolNameExpected    = teArrayNameExpected+1;
 teMatrixNameExpected = tePolNameExpected+1;
 teAnyArrNameExpected = tePolNameExpected+2;
 teNotExternAr      =  39;
 teNotExternPol     =  teNotExternAr+1;
 teNotExternMatrix  =  teNotExternPol+1;
 teParInCellVal     =  42;
 teEndFuncExpected  =  43;
 teFuncNameExpected =  44;
 teTooManyPars      =  45;
 teVarNameExpected  =  46;
 teFuncSignsExpected=  47;
 teCommaExpected    =  48;
 teFuncMismatch     =  49;
 tePolDefLoc        =  50;
 teEndArrDefExpected=  51;
 teInvArraySize     =  52;
 teFloatExpected    =  53;
 teTextEndExpected  =  54;
 teInvFormat        =  55;
 teParDiff          =  56;
 teStructNotOut     =  57;
 teConstExpected    =  58;
 teInvOutLoc        =  59;
 teInvParDefLoc     =  60;
 teStringNotOut     =  61;
 teStringDiff       =  62;
 teInvStringDefLoc  =  63;
 teStringDefExpected=  64;
 teStrExprExpected  =  65;
 teStringVarExpected=  66;
 teTooManyCells     =  67;
 teDimNotEqual      =  68;
 teStrArNoGeneral   =  69;
 teInvStrLenDef     =  70;
 teStrConstExpected =  71;
 teStrLenMismatch   =  72;
 teBigFloat         =  73;
 teNoFreeFuncId     =  74;
 teOpTypesMismatch  =  75;
 teProcNameExpected =  76;
 teExternBadLoc     =  77;
 teLocAsGlobal      =  78;
 teNotExistInGlobal =  79;
 teParInSizeVal     =  80;
 teUserVarExpected  =  81;
 teBadPrivOp        =  82;
 teUserTypeNotOut   =  83;
 teUserTypeDiff     =  84;
 teInvUserTypeDefLoc=  85;
 teCommaUnnecessary =  86;

 teEndCaseExpected  =  87;
 teEmptyCaseWE      =  88;
 teEmptyCase        =  89;
 teEndSwitchExpected=  90;
 teOfExpected       =  91;
 teColonExpected    =  92;
 teBadLibDefLoc     =  93;
 teLibDefNotFirst   =  94;
 teLibNameExpected  =  95;
 teUknownLib        =  96;
 teCantSwitchToLib  =  97;
 teCantAddLibrary   =  98;
 teBadUsesLoc       =  99;
 teLibIdentExpected =  100;
 teUknownIdent      =  101;
 teBadExportLoc     =  102;
 teInvUserObjDefLoc =  103;
 teObjectVarExpected=  104;
 teFuncNotEnable    =  105;
 teOperatorNotEnable=  106;
 teExportNotInLib   =  107;
 teUncompatibleUserVar=108;
 teUncompatibleObjectVar=109;
 teMethodByArg      =  110;
 teUnderObjOps      =  111;
 teObjMethodExpected=  112;
 teObjRefExpected   =  113;
 teRefExpected      =  114;
 teArrayIdExpected  =  115;
 teStaticUserExpected= 116;
 teBadPrivForAssign =  117;
 teObjIdentExpected =  118;
 teBadObjectPriv    =  119;
 tePointExpected    =  120;
 teObjOrMethIdExpected=121;
 teStaticObjExpected=  122;
 teObjRefIdExpected =  123;
 teBadRelOpObj      =  124;
 teReadOnly         =  125;
 teFloatDefExpected =  126;
 teConstExprExpected=  127;
 teObjectTypeExpected= 128;
 teInvFloatTypeDefLoc= 129;
 teInvRefFldExport  =  130;
 teInvIdExport      =  131;
 teAsExpected       =  132;
 teLibVarExpected   =  133;
 teProgCompiled     =  134;
 teProgNotOpen      =  135;
 teRunNotCompiled   =  136;
 teNotActual        =  137;
 teLibNameMismatch  =  138;
 teBadNextCaseLoc   =  139;
 teInvObjDefLoc     =  140;
 teObjFldIdExpected =  141;
 teMethodNotDeclare =  142;
 teMethodIdExpected =  143;
 teMethodReDef      =  144;
 teVirtualExpected  =  145;
 teMethodNotEqual   =  146;
 teInhNotVirtual    =  147;

Const
 MaxTermLen=15;   { Max   ଠ }
 MaxResWords=76;  { ᫮ १ࢨ஢  }

Type
 TermString=string[MaxTermLen];

 HLWord=record
  Hi,Lo:byte
 end;

 ResWordType=record
  Name:TermString;
  TermType:OpsType;
  TermWhat:word;
  Hash:byte;
 end;
 AResWords=array[1..MaxResWords] of ResWordType;
 PResWords=^AResWords;

Const

 off_Protected = 1;
 off_ReadOnly  = 2;
 off_Virtual   = 8;

 { reserved names }

 ResWords:AResWords=(
  (Name:'SIN'     ; TermType:opFunc1     ; TermWhat:f1Sin    ; Hash:28),
  (Name:'COS'     ; TermType:opFunc1     ; TermWhat:f1Cos    ; Hash:15),
  (Name:'TG'      ; TermType:opFunc1     ; TermWhat:f1Tg     ; Hash:22),
  (Name:'ARCSIN'  ; TermType:opFunc1     ; TermWhat:f1Arcsin ; Hash: 0),
  (Name:'ARCCOS'  ; TermType:opFunc1     ; TermWhat:f1Arccos ; Hash:19),
  (Name:'ARCTG'   ; TermType:opFunc1     ; TermWhat:f1Arctg  ; Hash: 0),
  (Name:'ABS'     ; TermType:opFunc1     ; TermWhat:f1Abs    ; Hash: 2),
  (Name:'SQR'     ; TermType:opFunc1     ; TermWhat:f1Sqr    ; Hash:10),
  (Name:'SQRT'    ; TermType:opFunc1     ; TermWhat:f1Sqrt   ; Hash: 6),
  (Name:'RAD'     ; TermType:opFunc1     ; TermWhat:f1Rad    ; Hash:26),
  (Name:'GRAD'    ; TermType:opFunc1     ; TermWhat:f1Grad   ; Hash:20),
  (Name:'LN'      ; TermType:opFunc1     ; TermWhat:f1Ln     ; Hash:28),
  (Name:'LG'      ; TermType:opFunc1     ; TermWhat:f1Lg     ; Hash: 6),
  (Name:'EXP'     ; TermType:opFunc1     ; TermWhat:f1Exp    ; Hash: 4),
  (Name:'SIGN'    ; TermType:opFunc1     ; TermWhat:f1Sign   ; Hash:24),
  (Name:'FRAC'    ; TermType:opFunc1     ; TermWhat:f1Frac   ; Hash:23),
  (Name:'ROUND'   ; TermType:opFunc1     ; TermWhat:f1Round  ; Hash:12),
  (Name:'TRUNC'   ; TermType:opFunc1     ; TermWhat:f1Trunc  ; Hash:15),
  (Name:'ERROR'   ; TermType:opFunc1     ; TermWhat:f1Error  ; Hash: 0),
  (Name:'DIV'     ; TermType:opFunc2     ; TermWhat:moLDiv   ; Hash: 3),
  (Name:'MOD'     ; TermType:opFunc2     ; TermWhat:moLMod   ; Hash:29),

  (Name:'EXTERN'  ; TermType:opExtern    ; TermWhat:0        ; Hash:21),
  (Name:'ARRAY'   ; TermType:opArrayDef  ; TermWhat:0        ; Hash:13),
  (Name:'POLINOM' ; TermType:opPolinomDef; TermWhat:0        ; Hash:29),
  (Name:'MATRIX'  ; TermType:opMatrixDef ; TermWhat:0        ; Hash:10),

  (Name:'OR'      ; TermType:opLogic     ; TermWhat:ltOR     ; Hash:18),
  (Name:'AND'     ; TermType:opLogic     ; TermWhat:ltAND    ; Hash:11),
  (Name:'XOR'     ; TermType:opLogic     ; TermWhat:ltXOR    ; Hash:25),
  (Name:'NOT'     ; TermType:opLogic     ; TermWhat:ltNOT    ; Hash: 2),

  (Name:'WHILE'   ; TermType:opWhile     ; TermWhat:0        ; Hash: 1),
  (Name:'ENDWHILE'; TermType:opEndWhile  ; TermWhat:0        ; Hash:19),
  (Name:'IF'      ; TermType:opIf        ; TermWhat:0        ; Hash:26),
  (Name:'ENDIF'   ; TermType:opEndIf     ; TermWhat:0        ; Hash: 5),
  (Name:'DO'      ; TermType:opDo        ; TermWhat:0        ; Hash:13),
  (Name:'THEN'    ; TermType:opThen      ; TermWhat:0        ; Hash:30),
  (Name:'ELSE'    ; TermType:opElse      ; TermWhat:0        ; Hash:27),
  (Name:'ENDELSE' ; TermType:opEndElse   ; TermWhat:0        ; Hash:28),
  (Name:'FUNC'    ; TermType:opFuncDef   ; TermWhat:0        ; Hash:25),
  (Name:'ENDFUNC' ; TermType:opEndFunc   ; TermWhat:0        ; Hash:30),
  (Name:'END'     ; TermType:opEnd       ; TermWhat:0        ; Hash:26),
  (Name:'REPEAT'  ; TermType:opRepeat    ; TermWhat:0        ; Hash: 0),
  (Name:'UNTIL'   ; TermType:opUntil     ; TermWhat:0        ; Hash: 5),
  (Name:'BREAK'   ; TermType:opBreak     ; TermWhat:0        ; Hash:10),
  (Name:'CONTINUE'; TermType:opContinue  ; TermWhat:0        ; Hash:25),
  (Name:'BEGIN'   ; TermType:opBegin     ; TermWhat:0        ; Hash:08),
  (Name:'DIAG'    ; TermType:opDiag      ; TermWhat:0        ; Hash: 0),
  (Name:'SIMMETR' ; TermType:opSimm      ; TermWhat:0        ; Hash:18),
  (Name:'OUT'     ; TermType:opOut       ; TermWhat:0        ; Hash:16),
  (Name:'PAR'     ; TermType:opParDef    ; TermWhat:0        ; Hash:28),
  (Name:'STRING'  ; TermType:opStringDef ; TermWhat:0        ; Hash:20),
  (Name:'PRINT'   ; TermType:opPrint     ; TermWhat:0        ; Hash:17),
  (Name:'EXIT'    ; TermType:opExit      ; TermWhat:0        ; Hash:11),
  (Name:'OF'      ; TermType:opOf        ; TermWhat:0        ; Hash:30),
  (Name:'PROC'    ; TermType:opProcDef   ; TermWhat:0        ; Hash:14),
  (Name:'FLOAT'   ; TermType:opFloatDef  ; TermWhat:0        ; Hash:11),
  (Name:'ISTRUE'  ; TermType:opCompFunc  ; TermWhat:rtIsOne  ; Hash:19),
  (Name:'ISFALSE' ; TermType:opCompFunc  ; TermWhat:rtIsZero ; Hash: 0),
  (Name:'CASE'    ; TermType:opCase      ; TermWhat:0        ; Hash: 0),
  (Name:'ENDCASE' ; TermType:opEndCase   ; TermWhat:0        ; Hash: 1),
  (Name:'ENDSWITCH';TermType:opEndSwitch ; TermWhat:0        ; Hash: 5),
  (Name:'LIBRARY' ; TermType:opLibDef    ; TermWhat:0        ; Hash:27),
  (Name:'USES'    ; TermType:opUses      ; TermWhat:0        ; Hash:23),
  (Name:'EXPORT'  ; TermType:opExport    ; TermWhat:0        ; Hash: 3),
  (Name:'INCLUDE' ; TermType:opInclude   ; TermWhat:0        ; Hash:18),
  (Name:'CONST'   ; TermType:opConstDef  ; TermWhat:0        ; Hash: 0),
  (Name:'DEFINE'  ; TermType:opDefine    ; TermWhat:0        ; Hash:25),
  (Name:'AS'      ; TermType:opAs        ; TermWhat:0        ; Hash:23),
  (Name:'VAR'     ; TermType:opVarDef    ; TermWhat:0        ; Hash:20),
  (Name:'NEXTCASE'; TermType:opNextCase  ; TermWhat:0        ; Hash:14),
  (Name:'RESIDENT'; TermType:opResident  ; TermWhat:0        ; Hash: 4),
  (Name:'NONRESIDENT';TermType:opResident; TermWhat:1        ; Hash:18),
  (Name:'OBJECT'  ; TermType:opObjectDef ; TermWhat:0        ; Hash:12),
  (Name:'PROTECTED';TermType:opFieldAtr  ; TermWhat:off_Protected; Hash:13),
  (Name:'READONLY'; TermType:opFieldAtr  ; TermWhat:off_ReadOnly; Hash:12),
  (Name:'VIRTUAL' ; TermType:opFieldAtr  ; TermWhat:off_Virtual; Hash:22),
  (Name:'METHOD'  ; TermType:opMethod    ; TermWhat:0        ; Hash: 3)
  );

Const
 MaxSpecialChar=21;
 SpecialString:string[MaxSpecialChar]='+-/*();,= %@.^[]'':!><';
 PSpecialString:pointer=@SpecialString;

 Diff1Char='`';
 Diff2Char='"';
 AssignChar='=';
 GreatChar='>';
 TextChar='''';
 PointChar='.';
 AmperChar='@';

 scRBrack= 16;
 scG     = 20;
 scL     = 21;
 scText  = 17;
 scColon = 18;
 scV     = 19;
 scBlank = 10;
 scPoint = 13;

Type
 RSpecialChars=record
  Stype:OpsType;
  What:byte
 end;

Const
 SpecialChars:array[1..MaxSpecialChar] of RSpecialChars=(
  (Stype:opFunc2      ; What:moPlus  ),
  (Stype:opFunc2      ; What:moMinus ),
  (Stype:opFunc2      ; What:moDiv   ),
  (Stype:opFunc2      ; What:moMult  ),
  (Stype:opLBra       ; What:0       ),
  (Stype:opRBra       ; What:0       ),
  (Stype:opSemiColon  ; What:0       ),
  (Stype:opComma      ; What:0       ),
  (Stype:opAssign     ; What:rtE     ),
  (Stype:opBlank      ; What:0       ),
  (Stype:opFunc2      ; What:moLMod  ),
  (Stype:opOutSign    ; What:0       ),
  (Stype:opPoint      ; What:0       ),
  (Stype:opFunc2      ; What:moPower ),
  (Stype:opLBrack     ; What:0       ),
  (Stype:opRBrack     ; What:0       ),
  (Stype:opText       ; What:0       ),
  (Stype:opColon      ; What:0       ),
  (Stype:opV          ; What:0       ),
  (Stype:opRel        ; What:rtG     ),
  (Stype:opRel        ; What:rtL     ) );

 BlankPos=10;

 MaxFuncPars=10; { max ᫮ ࠬ஢ - }
 FuncMask=$F400;
 AllMask=$FFFF;
 VarMask=AllMask and not FuncMask;
 TextTermSize=255;    { max  ப ६ }

 stFormat1=10; { ଠ ᫠  㬮砭 }
 stFormat2=6;

 DefLib2x2Ext:string[4]='.2x2';
 ShortBoolEval:boolean=False;

 ffSimpleIfAllConst = $0001;
 ffMethod           = $0002;
 ffVirtual          = $0004;
 ffFloatFunc        = $0010;
 ffStrFunc          = $0020;
 ffProc             = $0040;
 ffPersistant       = $0200;
 ffProperty         = $0400;
 ffAsMethodEnable   = $1000;
 ffNotCreated       = $2000;

 oftObjField     =  1;
 oftObjName      = -1;
 oftChildObjName = -2;

 oitUknown    = 0;
 oitField     = 1;
 oitObject    = 2;
 oitRefObject = 3;
 oitMethod    = 4;

 cfVirtual = 1;
 cfRefObj  = 2;

 tpAny    = 0;
 tpObj    = 1;
 tpObjRef = 2;

 Method_Flag = 1;

 _InitLibProc='_INITLIB';
 _DoneLibProc='_DONELIB';

 AutoUnloadLib:boolean=False;

Type
 TFldOptions=(offVirtual,offProtected,offReadOnly);
 TFldOption=set of TFldOptions;

 TextTerm=string[TextTermSize-1];
 PText=^TextTerm;

 ListModeType=(lmParList,lmOutList,lmStringList,lmUserVarList,lmUserObjList,
  lmUsesList,lmExportList,lmFloatVarList);
 OutPrintModeType=(pmPrint,pmOut);

 TMOOperations=moPlus..moLMod;
 TOperations=set of TMOOperations;
 TUnar=f1Neg..f1Error;
 TUnarFuncs=set of TUnar;

Implementation

End.