{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Hash2x2; {   }
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Calcer,X1,Def2x2,Objects,Diffy;

Type

 AHash=array[0..MaxHashKey-1] of PHashCell; { -⠡ }

 PTermHash=^TTermHash;
 TTermHash=object(TObject)   {  ମ }
  Prev:PTermHash;            {  ।饣 ஢ }
  Owner:PACompilator;        { ,   }
  Hash:AHash;                { -⠡ }
  constructor Init(AOwner:PACompilator; APrev:PTermHash);
  function Search(Const N:string; MakeItem:boolean; TypeMask:word; Var H:PHashCell):boolean;virtual;
  function Add(HKey:integer; AddH:PHashCell):boolean;
  function AddFromHash(SrcHash:PTermHash):boolean;
  procedure EnablePrevLevel(On:boolean);virtual;
 end;

 PStandardHash=^TStandardHash;
 TStandardHash=object(TTermHash)  {  १. ᫮ }
  constructor Init(AOwner:PACompilator; APrev:PTermHash; NeedRW:boolean);
  function Find(Const N:string; Var H:PHashCell):boolean;
  procedure RegisterRW(RW:PResWords; Nums:word);
 end;

 PObjDefHash=^TObjDefHash;
 TObjDefHash=object(TTermHash)  {  }
  FieldsList:PCollection;
  PrevLevel:boolean;
  InhObj:pointer;
  EnableFuncEq:boolean;
  constructor Init(AOwner:PACompilator; APrev:PTermHash);
  function Search(Const N:string; MakeItem:boolean; TypeMask:word; Var H:PHashCell):boolean;virtual;
  destructor Done;virtual;
  procedure EnablePrevLevel(On:boolean);virtual;
 end;

Implementation
Uses UserFunc;

constructor TTermHash.Init(AOwner:PACompilator; APrev:PTermHash);
begin
 Owner:=AOwner;
 Prev:=APrev;
 FillChar(Hash,MaxHashKey*SizeOf(pointer),0)
end;

function TTermHash.Search(const N:string; MakeItem:boolean;
 TypeMask:word; var H:PHashCell):boolean;
{   N  . TypeMask -, । -   ⨯
  ᪠ - ।  (AllMask)  ⮫쪮 ।  - (FuncMask).
  ᫨   ,   ।  - (TypeMask=FuncMask)
    ᮪ ஢ (Prev). ᫨  ⠬   
  MakeItem=True,  ᮧ-  -  }
var K:PHashCell;
begin
 H:=Hash[CurHashKey];
 K:=H;
 While H<>nil do begin
  If H^.HVal^.TermType and TypeMask=H^.HVal^.TermType then
   If H^.HVal^.Name=N then begin
    Search:=True; H:=H^.HVal; exit
   end;
  K:=H;
  H:=H^.Next
 end;

 If Prev<>nil then
  If Prev^.Search(N,False,FuncMask,H) then begin
   Search:=True; exit
  end;

 If MakeItem then begin
  H:=Owner^.NewMem(SizeOf(THashCell));
  H^.Next:=nil;
  H^.Name:=N;
  H^.HFlags:=0;
  If K=nil then Hash[CurHashKey]:=H else K^.Next:=H;
  H^.HVal:=H
 end;
 Search:=False
end;

procedure TTermHash.EnablePrevLevel(On:boolean);
begin end;

constructor TObjDefHash.Init(AOwner:PACompilator; APrev:PTermHash);
begin
 TObject.Init;
 Owner:=AOwner;
 Prev:=APrev;
 PrevLevel:=False;
 EnableFuncEq:=False;
 FieldsList:=New(PCollection,Init(16,16));
end;

procedure TObjDefHash.EnablePrevLevel(On:boolean);
begin
 PrevLevel:=On
end;

function TObjDefHash.Search(const N:string; MakeItem:boolean; TypeMask:word; var H:PHashCell):boolean;
var FH:PHashcell; i:integer; b:boolean;
begin
 For i:=0 to FieldsList^.Count-1 do begin
  FH:=FieldsList^.At(i);
  If FH^.HVal^.TermType and TypeMask=FH^.HVal^.TermType then
   If FH^.HVal^.Name=N then begin
    H:=FH^.HVal; Search:=True; exit
   end;
 end;

 i:=P2x2Object(InhObj)^.FindByName(N);
 If i<>0 then begin
  b:=True;
  If EnableFuncEq then begin
   case P2x2Object(InhObj)^.FindByNum(i)^.FType of
    opUserFunc,opStringFunc,opUserProc,opParFunc,opParStrFunc,opParProc: b:=False;
   end
  end;
  If b then begin
   H:=Owner^.NewMemTmp(SizeOf(THashCell));
   H^.TermType:=opFPar;
   Search:=True; exit
  end
 end;

 If PrevLevel and (Prev<>nil) then
  If Prev^.Search(N,False,AllMask,FH) then begin
   Search:=True; H:=FH^.HVal; exit
  end;

 If MakeItem then begin
  If EnableFuncEq then FH:=Owner^.NewMem(SizeOf(THashCell))
  else FH:=Owner^.NewMemTmp(SizeOf(THashCell));
  FH^.Next:=nil;
  FH^.Name:=N;
  FH^.HFlags:=0;
  FH^.HVal:=FH;
  FieldsList^.Insert(FH);
  H:=FH
 end;
 Search:=False
end;

destructor TObjDefHash.Done;
begin
 FieldsList^.DeleteAll;
 Dispose(FieldsList,Done);
 Inherited Done
end;

function TTermHash.AddFromHash(SrcHash:PTermHash):boolean;
var i:integer; H:PHashCell;
begin
 For i:=0 to MaxHashKey-1 do begin
  H:=SrcHash^.Hash[i];
  While H<>nil do begin
   If H^.TermType<>opLib then Add(i,H);
   H:=H^.Next
  end
 end
end;

function TTermHash.Add(HKey:integer; AddH:PHashCell):boolean;
var K,H:PHashCell; Er:integer; N:string;
begin
 N:=AddH^.HVal^.Name;
 H:=Hash[HKey];
 K:=H;
 While H<>nil do begin
  If H^.HVal^.Name=N then begin
   Add:=False; exit
  end;
  K:=H;
  H:=H^.Next
 end;

 H:=Owner^.NewMemTmp(SizeOf(THashCell));
 H^.Next:=nil;
 H^.Name:=N;
 If K=nil then Hash[HKey]:=H else K^.Next:=H;
 H^.HVal:=AddH^.HVal;
 Add:=True
end;

function TStandardHash.Find(const N:string; var H:PHashCell):boolean;
{ 頥 True, ᫨  N - १ࢨ.  }
begin
 H:=Hash[CurHashKey];
 While H<>nil do begin
  If H^.Name=N then begin
   Find:=True; H:=H^.HVal; exit
  end;
  H:=H^.Next
 end;
 Find:=False
end;

constructor TStandardHash.Init(AOwner:PACompilator; APrev:PTermHash; NeedRW:boolean);
begin
 Inherited Init(AOwner,APrev);
 { ॣ- १.  }
 If NeedRW then RegisterRW(@ResWords,MaxResWords);
end;

procedure TStandardHash.RegisterRW(RW:PResWords; Nums:word);
var i,H:byte; P,K:PHashCell;
begin
 For i:=1 to Nums do begin
  H:=RW^[i].Hash;
  If H>=MaxHashKey then continue;
  P:=Owner^.NewMemTmp(SizeOf(THashCell));
  P^.HVal:=P;
  P^.Next:=nil;
  K:=Hash[H];
  If K=nil then Hash[H]:=P
  else begin
   While K^.Next<>nil do K:=K^.Next;
   K^.Next:=P
  end;
  FastMove(ResWords[i],P^,SizeOf(ResWordType)-1)
 end
end;

End.
